package com.gic.haoban.manage.service.service.impl;

import com.gic.haoban.manage.service.entity.TabHaobanAppOrder;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanAppOrderMapper;
import com.gic.haoban.manage.service.service.TabHaobanAppOrderService;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;

import javax.annotation.Resource;

/**
 * (TabHaobanAppOrder)表服务实现类
 *
 * @author makejava
 * @since 2023-06-21 17:24:20
 */
@Service("tabHaobanAppOrderService")
public class TabHaobanAppOrderServiceImpl implements TabHaobanAppOrderService {
    @Resource
    private TabHaobanAppOrderMapper tabHaobanAppOrderMapper;

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public TabHaobanAppOrder queryById(Long id) {
        return this.tabHaobanAppOrderMapper.queryById(id);
    }

    /**
     * 分页查询
     *
     * @param tabHaobanAppOrder 筛选条件
     * @param pageRequest      分页对象
     * @return 查询结果
     */
    @Override
    public Page<TabHaobanAppOrder> queryByPage(TabHaobanAppOrder tabHaobanAppOrder, PageRequest pageRequest) {
        long total = this.tabHaobanAppOrderMapper.count(tabHaobanAppOrder);
        return new PageImpl<>(this.tabHaobanAppOrderMapper.queryAllByLimit(tabHaobanAppOrder, pageRequest), pageRequest, total);
    }

    /**
     * 新增数据
     *
     * @param tabHaobanAppOrder 实例对象
     * @return 实例对象
     */
    @Override
    public TabHaobanAppOrder insert(TabHaobanAppOrder tabHaobanAppOrder) {
        this.tabHaobanAppOrderMapper.insert(tabHaobanAppOrder);
        return tabHaobanAppOrder;
    }

    /**
     * 修改数据
     *
     * @param tabHaobanAppOrder 实例对象
     * @return 实例对象
     */
    @Override
    public TabHaobanAppOrder update(TabHaobanAppOrder tabHaobanAppOrder) {
        this.tabHaobanAppOrderMapper.update(tabHaobanAppOrder);
        return this.queryById(tabHaobanAppOrder.getId());
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Long id) {
        return this.tabHaobanAppOrderMapper.deleteById(id) > 0;
    }
}
